Graphics3D 1024, 768, 32, 2
SetBuffer BackBuffer()

;Globs
Global sh_v1.Point3D, sh_v2.Point3D, sh_v3.Point3D, sh_nv1.Point3D, sh_nv2.Point3D, sh_nv3.Point3D, sh_vect1.Point3D, sh_vect2.Point3D, sh_vect3.Point3D, sh_light.Point3D, sh_lenght.Point3D, sh_normal.Point3D, sh_NCamera.Point3D
Global VolumeMesh, VolumeSurface
Dim Edge.Edge(65000)

;Camera
Cam = CreateCamera()

;Shadows
InitShadows()

;Floor
c = CreateCube()
ScaleEntity c, 10, 1, 10
PositionEntity c, 0, -5, 10
EntityColor c, 0, 255, 0

;Caster
;Cube = CreateSphere(16)
;PositionEntity Cube, -1.5, 0, 10

Global cube=LoadMesh("imp.x")
ScaleEntity cube,0.03,0.03,0.03
Global dragonskin = LoadTexture("imp_d.png")
EntityTexture cube,dragonskin,0,3
RotateEntity cube,0,0,0
PositionEntity cube, -1.5, 0, 10

Cube2 = CreateCube()
PositionEntity Cube2, 1.5, 0, 10

;Light
Light = CreateLight()
PositionEntity Light, 0, 5, 10

While Not KeyHit(1)
	ms = ms + 1
	PointEntity Light, Cube
	TurnEntity Cube, 1, .5, 1.5
	TurnEntity Cube2, 1, .5, 1.5
	ResetShadowVolume()
	ShadowVolume(Cube, Light)
	ShadowVolume(Cube2, Light)
	RenderWorld
	Flip
Wend
FreeShadows()
End



;Types
Type Point3D
	Field x#, y#, z#
End Type
Type Edge
	Field Surf, Triangle
	Field Point0.Point3D, Point1.Point3D, Ray0.Point3D, Ray1.Point3D
End Type

Function InitShadows()
;Volume mesh
VolumeMesh = CreateMesh()
VolumeSurface = CreateSurface(VolumeMesh)
EntityAlpha VolumeMesh, .5
EntityColor VolumeMesh, 255, 0, 0
EntityFX VolumeMesh, 17
;Edges
For a = 0 To 65000
	Edge.Edge(a) = New Edge
	Edge(a)\Point0.Point3D = New Point3D
	Edge(a)\Point1.Point3D = New Point3D
	Edge(a)\Ray0.Point3D = New Point3D
	Edge(a)\Ray1.Point3D = New Point3D
Next
;Points
sh_v1.Point3D = New Point3D
sh_v2.Point3D = New Point3D
sh_v3.Point3D = New Point3D
sh_light.Point3D = New Point3D
sh_lenght.Point3D = New Point3D
End Function

Function FreeShadows()
If VolumeMesh Then FreeEntity VolumeMesh
Delete Each Point3D
Delete Each Edge
End Function

Function V3_Inc.Point3D(val1.Point3D, val2.Point3D)
val1\x = val1\x + val2\x
val1\y = val1\y + val2\y
val1\z = val1\z + val2\z
Return val1
End Function

Function V3_Dec.Point3D(val1.Point3D, val2.Point3D, val3.Point3D)
val3\x = val1\x - val2\x
val3\y = val1\y - val2\y
val3\z = val1\z - val2\z
End Function

Function V3_Mul.Point3D(val1.Point3D, val2.Point3D)
val1\x = val1\x * val2\x
val1\y = val1\y * val2\y
val1\z = val1\z * val2\z
Return val1
End Function

Function V3_Copy(a.Point3D, b.Point3D)
a\x# = b\x#
a\y# = b\y#
a\z# = b\z#
End Function

Function V3_Normalize(val.Point3D)
do# = 1.0 / Float(Sqr(val\x*val\x  + val\y*val\y + val\z*val\z))
val\x = val\x * do
val\y = val\y * do
val\z = val\z * do
End Function

Function V3_CheckVertex(a.Point3D, b.Point3D)
If a\x = b\x And a\y = b\y And a\z = b\z Then Return True Else Return False
End Function

Function ResetShadowVolume()
ClearSurface VolumeSurface
End Function

Function ShadowVolume(model, Light)
sh_light\x = EntityX(Light)
sh_light\y = EntityY(Light)
sh_light\z = EntityZ(Light)
sh_lenght\x = 1000
sh_lenght\y = 1000
sh_lenght\z = 1000
Norm.Point3D = New Point3D
MidPoint.Point3D = New Point3D
NormLight.Point3D = New Point3D
For n = 1 To CountSurfaces(model)
	surf = GetSurface(model, n)
	dwNumFaces = CountTriangles(surf) - 1
	For v = 0 To dwNumFaces
		vert0 = TriangleVertex(surf, v, 0)
		vert1 = TriangleVertex(surf, v, 1)
		vert2 = TriangleVertex(surf, v, 2)
		TFormPoint VertexX(surf, vert0), VertexY(surf, vert0), VertexZ(surf, vert0), model, 0
		sh_v1\x = TFormedX()
		sh_v1\y = TFormedY()
		sh_v1\z = TFormedZ()
		TFormPoint VertexX(surf, vert1), VertexY(surf, vert1), VertexZ(surf, vert1), model, 0
		sh_v2\x = TFormedX()
		sh_v2\y = TFormedY()
		sh_v2\z = TFormedZ()
		TFormPoint VertexX(surf, vert2), VertexY(surf, vert2), VertexZ(surf, vert2), model, 0
		sh_v3\x = TFormedX()
		sh_v3\y = TFormedY()
		sh_v3\z = TFormedZ()
		aa.Point3D = New Point3D
		bb.Point3D = New Point3D
		V3_Dec(sh_v3, sh_v2, aa.Point3D)
		V3_Dec(sh_v2, sh_v1, bb.Point3D)
		ax# = aa\y# * bb\z# - aa\z# * bb\y#
		ay# = aa\z# * bb\x# - aa\x# * bb\z#
		az# = aa\x# * bb\y# - aa\y# * bb\x#
		Norm\x# = ax#
		Norm\y# = ay#
		Norm\z# = az#
		Delete aa
		Delete bb
		MidPoint\x = (sh_v1\x# + sh_v2\x# + sh_v3\x) / 3
		MidPoint\y = (sh_v1\y# + sh_v2\y# + sh_v3\y) / 3
		MidPoint\z = (sh_v1\z# + sh_v2\z# + sh_v3\z) / 3
		V3_Dec(MidPoint, sh_light, NormLight)
		V3_Normalize(Norm)
		V3_Normalize(NormLight)
		Dot# = Norm\x# * NormLight\x# + Norm\y# * NormLight\y# + Norm\z# * NormLight\z#
		If Dot# => 0 And Dot# <= 1 Then
			ID_EdgeF.Edge = Edge(CNTFront)
			ID_EdgeF\Surf = surf
			ID_EdgeF\Triangle = v
			V3_Copy(ID_EdgeF\Point0, sh_v1)
			V3_Copy(ID_EdgeF\Point1, sh_v2)
			CNTFront = CNTFront + 1
			ID_EdgeF.Edge = Edge(CNTFront)
			ID_EdgeF\Surf = surf
			ID_EdgeF\Triangle = v
			V3_Copy(ID_EdgeF\Point0, sh_v2)
			V3_Copy(ID_EdgeF\Point1, sh_v3)
			CNTFront = CNTFront + 1
			ID_EdgeF.Edge = Edge(CNTFront)
			ID_EdgeF\Surf = surf
			ID_EdgeF\Triangle = v
			V3_Copy(ID_EdgeF\Point0, sh_v3)
			V3_Copy(ID_EdgeF\Point1, sh_v1)
			CNTFront = CNTFront + 1
		EndIf
	Next
Next
cntUguali = 0
cntDiverse = 0
For a = 0 To CNTFront
	If Edge(a)\surf > 0 Then
		Diverso = True
		MemB = 0
		ID_EdgeFA.Edge = Edge(a)
		ID_P0.Point3d = ID_EdgeFA\Point0
		ID_P1.Point3d = ID_EdgeFA\Point1
		For b = a + 1 To CNTFront
			ID_EdgeFB.Edge = Edge(b)
			If Edge(b)\surf > 0 Then
				check1 = V3_CheckVertex(ID_P0, ID_EdgeFB\Point0)
				check2 = V3_CheckVertex(ID_P1, ID_EdgeFB\Point1)
				If check1 And check2 Then
					MemB = b
					cntUguali = cntUguali + 1
					ID_EdgeFA\surf = 0
					ID_EdgeFB\surf = 0
					Diverso = False
					Exit
				Else
					check1 = V3_CheckVertex(ID_P0, ID_EdgeFB\Point1)
					check2 = V3_CheckVertex(ID_P1, ID_EdgeFB\Point0)
					If check1 And check2 Then
						MemB = b
						cntUguali = cntUguali + 1
						ID_EdgeFA\surf = 0
						ID_EdgeFB\surf = 0
						Diverso = False
						Exit
					EndIf
				EndIf
			EndIf
		Next
		If Diverso Then
			cntDiverse = cntDiverse + 1
			V3_Dec(ID_P0, sh_light, ID_EdgeFA\Ray0)
			V3_Normalize(ID_EdgeFA\Ray0)
			ID_EdgeFA\Ray0 = V3_Inc(V3_Mul(ID_EdgeFA\Ray0, sh_lenght), ID_P0)
			V3_Dec(ID_P1, sh_light, ID_EdgeFA\Ray1)
			V3_Normalize(ID_EdgeFA\Ray1)
			ID_EdgeFA\Ray1 = V3_Inc(V3_Mul(ID_EdgeFA\Ray1, sh_lenght), ID_P1)
			va = AddVertex(VolumeSurface, ID_P0\x, ID_P0\y, ID_P0\z)
			vb = AddVertex(VolumeSurface, ID_EdgeFA\Ray1\x, ID_EdgeFA\Ray1\y, ID_EdgeFA\Ray1\z)
			AddTriangle(VolumeSurface, va, AddVertex(VolumeSurface, ID_EdgeFA\Ray0\x, ID_EdgeFA\Ray0\y, ID_EdgeFA\Ray0\z), vb)
			AddTriangle(VolumeSurface, va, vb, AddVertex(VolumeSurface, ID_P1\x, ID_P1\y, ID_P1\z))
			ID_EdgeFA\surf = 0
			Edge(MemB)\surf = 0
		EndIf
	EndIf
Next
Delete Norm.Point3D
Delete MidPoint.Point3D
Delete NormLight.Point3D
End Function